/******************************************/ 
/* Carbon-compatible section of OroborOSX */
/* (c) Adrian Umpleby Jan 2002            */
/*                                        */
/* Original oroborus window manager code  */
/* (c) Ken Lynch Jan 2001                 */
/*                                        */
/* Distributed under the GPL              */ 
/* See LICENSE for more details           */ 
/******************************************/ 
 
/* trace.c */

#include <stdlib.h> 
#include <stdio.h>
#include <string.h> 

#include "trace.h"

char		lastsub[255];
char		*lastsub15, *lastsub14, *lastsub13, *lastsub12, *lastsub11;
char		*lastsub10, *lastsub9, *lastsub8, *lastsub7, *lastsub6;
char		*lastsub5, *lastsub4, *lastsub3, *lastsub2, *lastsub1;

/*
 * For debugging purposes...
 */
void subtrace()
{
    free(lastsub15);
    lastsub15=lastsub14;
    lastsub14=lastsub13;
    lastsub13=lastsub12;
    lastsub12=lastsub11;
    lastsub11=lastsub10;
    lastsub10=lastsub9;
    lastsub9=lastsub8;
    lastsub8=lastsub7;
    lastsub7=lastsub6;
    lastsub6=lastsub5;
    lastsub5=lastsub4;
    lastsub4=lastsub3;
    lastsub3=lastsub2;
    lastsub2=lastsub1;
    lastsub1=strdup(lastsub);
}

void show_last_ten()
{
    printf("Trace info: Last ten routines:\n");
    printf("  %s",lastsub10);
    printf("  %s",lastsub9);
    printf("  %s",lastsub8);
    printf("  %s",lastsub7);
    printf("  %s",lastsub6);
    printf("  %s",lastsub5);
    printf("  %s",lastsub4);
    printf("  %s",lastsub3);
    printf("  %s",lastsub2);
    printf("  %s",lastsub1);
}

void show_last_fifteen()
{
    printf("Trace info: Last fifteen routines:\n");
    printf("  %s",lastsub15);
    printf("  %s",lastsub14);
    printf("  %s",lastsub13);
    printf("  %s",lastsub12);
    printf("  %s",lastsub11);
    printf("  %s",lastsub10);
    printf("  %s",lastsub9);
    printf("  %s",lastsub8);
    printf("  %s",lastsub7);
    printf("  %s",lastsub6);
    printf("  %s",lastsub5);
    printf("  %s",lastsub4);
    printf("  %s",lastsub3);
    printf("  %s",lastsub2);
    printf("  %s",lastsub1);
}


