/*************************************/ 
/* Original oroborus window manager  */
/* (c) Ken Lynch Jan 2001            */
/*                                   */
/* Extra functionality for OroborOSX */
/* (c) Adrian Umpleby Jan 2002       */
/*                                   */
/* Distributed under the GPL         */ 
/* See LICENSE for more details      */ 
/*************************************/ 
 
#ifndef COMMUNICATION_H 
#define COMMUNICATION_H 

#define MAIN_SOCKET_PATH "/tmp/.OroborOSX_main_socket"

extern int main_socket, xdarwin_socket;

/* communication.c */ 
extern int init_listen_socket(char *pathstr);
extern int check_listen_accept(int s);
extern void end_listen_socket(int s, char *pathstr);
extern int check_listen_recv(int s);
extern int get_bytes_from_socket(int s, int rcvlen, char *str);
extern int check_listen_get_bytes(int s, char *str);
extern int check_listen_accept_name(int s, char *str);
 
#endif 
